% e4 grammar for the wumpus world
%
% example: s(Tree,[i,go],[]).
%          s(Tree,[the,agent,goes,north],[]).
%          s(Tree,[the,wumpus,is,dead],[]).
%          s(Tree,[i,shoot,me],[]).


s(s(NP,VP)) --> np(Person,nominative,NP),vp(Person,VP).

np(Person,Case,np(Pronoun)) --> pronoun(Person,Case,Pronoun).
np(3,_,np(Article,Noun))    --> article(Article),noun(Noun).

vp(Person,vp(Verb))           --> verb(Person,Verb).
vp(Person,vp(Verb,Adverb))    --> verb(Person,Verb),adverb(Adverb).
vp(Person,vp(Verb,Adjective)) --> verb(Person,Verb),adjective(Adjective).
vp(Person,vp(Verb,PP))        --> verb(Person,Verb),pp(PP).
vp(Person,vp(Verb,NP))        --> verb(Person,Verb),np(_,accusative,NP).

pp(pp(Preposition,Article,Noun)) --> preposition(Preposition),
                                     article(Article),
                                     noun(Noun).


% load knowledgebase

:- consult('knowledgebase_4.pl').
