% e5 grammar for the wumpus world
%
% example: s(Actor,Action,[i,go,north],[]).
%          s(Actor,Action,[the,agent,goes,north],[]).
%          s(Actor,Action,[the,wumpus,is,dead],[]).
%          s(Actor,Action,[i,shoot,me],[]).


s(Actor,Action) --> np(Person,nominative,Actor),vp(Person,Action).

np(Person,Case,Actor) --> pronoun(Person,Case,Actor).
np(3,_,Actor)         --> article,noun(Actor).

vp(Person,Action) --> verb(Person,Action,Param),(adverb(Param);
                                                 adjective(Param);
                                                 pp(Param);
                                                 np(_,accusative,Param)).

pp(Param) --> preposition,article,noun(Param).


% load knowledgebase

:- consult('knowledgebase_5.pl').
